# modules defaults
%define modulefile_path_top /opt/share/Modules/modulefiles/nvhpc

Version:	20.7
%define nversion %(echo %{version} | tr . -)
%define year 2020
Name:		pu-nvhpc-%{nversion}
Release:	2%{?dist}
Summary:	PU Wrapper for Nvidia HPC
Group:		Development/Libraries
License:	Other
Requires:	environment-modules
Requires:	nvhpc-%{nversion}
Requires:	nvhpc-%{nversion}-cuda-multi
Requires:	nvhpc-%{year}
Requires:	hardlink
Provides:	libnvcpumath.so()(64bit)
Provides:	libnvc.so()(64bit)
Provides:	libnvomp.so()(64bit)
Provides:	libnvf.so()(64bit)
Provides:	libnvhpcatm.so()(64bit)

%description
Wrapper for NVIDIA HPC Tools

%prep

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{modulefile_path_top}
mkdir -p $RPM_BUILD_ROOT/%{modulefile_path_top}-nocompiler
cat <<ENDCOREMODULE > ${RPM_BUILD_ROOT}%{modulefile_path_top}/%{version}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# %{name} rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds NVidia HPC %{version} to various paths"
}

module-whatis   "Sets up %{name} %{version} in your environment"

set nvhome /opt/nvidia/hpc_sdk
set target Linux_%{_arch}
set version %{version}

set nvcudadir \$nvhome/\$target/\$version/cuda
set nvcompdir \$nvhome/\$target/\$version/compilers
set nvprofdir \$nvhome/\$target/\$version/profilers
set nvmathdir \$nvhome/\$target/\$version/math_libs
set nvcommdir \$nvhome/\$target/\$version/comm_libs

setenv NVHPC \$nvhome
setenv CC \$nvcompdir/bin/nvc
setenv CXX \$nvcompdir/bin/nvc++
setenv FC \$nvcompdir/bin/nvfortran
setenv F90 \$nvcompdir/bin/nvfortran
setenv F77 \$nvcompdir/bin/nvfortran
setenv CPP cpp

prepend-path PATH \$nvcudadir/bin
prepend-path PATH \$nvcompdir/bin
prepend-path PATH \$nvprofdir/bin
prepend-path PATH \$nvcommdir/nccl/bin
prepend-path PATH \$nvcommdir/nvshmem/bin

prepend-path LD_LIBRARY_PATH \$nvcudadir/lib64
prepend-path LD_LIBRARY_PATH \$nvcompdir/lib
prepend-path LD_LIBRARY_PATH \$nvmathdir/lib64
prepend-path LD_LIBRARY_PATH \$nvcommdir/nccl/lib
prepend-path LD_LIBRARY_PATH \$nvcommdir/nvshmem/lib

prepend-path CPATH \$nvcudadir/include
prepend-path CPATH \$nvcompdir/include
prepend-path CPATH \$nvmathdir/include
prepend-path CPATH \$nvcommdir/nccl/include
prepend-path CPATH \$nvcommdir/nvshmem/include

prepend-path MANPATH \$nvcompdir/man
ENDCOREMODULE

cat <<ENDCOREMODULE > ${RPM_BUILD_ROOT}%{modulefile_path_top}-nocompiler/%{version}
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# %{name} rpm).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds NVidia HPC %{version} to various paths"
}

module-whatis   "Sets up %{name} %{version} in your environment"

set nvhome /opt/nvidia/hpc_sdk
set target Linux_%{_arch}
set version %{version}

set nvcudadir \$nvhome/\$target/\$version/cuda
set nvprofdir \$nvhome/\$target/\$version/profilers
set nvmathdir \$nvhome/\$target/\$version/math_libs
set nvcommdir \$nvhome/\$target/\$version/comm_libs

setenv NVHPC \$nvhome

prepend-path PATH \$nvcudadir/bin
prepend-path PATH \$nvprofdir/bin
prepend-path PATH \$nvcommdir/nccl/bin
prepend-path PATH \$nvcommdir/nvshmem/bin

prepend-path LD_LIBRARY_PATH \$nvcudadir/lib64
prepend-path LD_LIBRARY_PATH \$nvmathdir/lib64
prepend-path LD_LIBRARY_PATH \$nvcommdir/nccl/lib
prepend-path LD_LIBRARY_PATH \$nvcommdir/nvshmem/lib

prepend-path CPATH \$nvcudadir/include
prepend-path CPATH \$nvmathdir/include
prepend-path CPATH \$nvcommdir/nccl/include
prepend-path CPATH \$nvcommdir/nvshmem/include
ENDCOREMODULE

%post
/usr/sbin/hardlink -c /usr/local/cuda-* /opt/pgi/ /opt/nvidia/ >/dev/null 2>&1 || :

%triggerin -- cudatoolkit101-devel cudatoolkit102-devel cudatoolkit92 cudatoolkit102 cudatoolkit100-devel cudatoolkit110 cudatoolkit100 cudatoolkit101 cudatoolkit110-devel
/usr/sbin/hardlink -c /usr/local/cuda-* /opt/pgi/ /opt/nvidia/ >/dev/null 2>&1 || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{modulefile_path_top}
%{modulefile_path_top}/*
%dir %{modulefile_path_top}-nocompiler
%{modulefile_path_top}-nocompiler/*

%changelog
* Mon Sep 14 2020 Josko Plazonic <plazonic@princeton.edu>
- initial
